#include <windows.h>
#include <stdio.h>

#define ID_OK     1
#define ID_CANCEL 2
#define ID_CLOSE  3
#define ID_SOUP  11
#define ID_MEAL  12
#define ID_DRINK 13
#define ID_TEA   21
#define ID_COFFE 22
#define ID_WATER 33
#define ID_HUNGRY 41
#define HungryRange 100
#define ID_NAME 51
#define ID_TITLE 61

LRESULT CALLBACK ExamWndProc
     ( HWND hWnd, UINT Message, UINT wParam, LONG lParam );


int WINAPI WinMain(HINSTANCE hInstance,     //  
                   HINSTANCE hPrevInstance, //   
                   LPSTR lpszCmdParam,      //  
                   int nCmdShow)            //  

{ HWND hWnd;           //  
  WNDCLASS WndClass;   //   
  MSG Msg;             //  ""
  char szClassName[] = "Example3"; //   

  /*    */
  WndClass.style = 0; //  
  WndClass.lpfnWndProc = ExamWndProc; //    !
  WndClass.cbClsExtra = 0; //  
  WndClass.cbWndExtra = 0; //  
  WndClass.hInstance = hInstance; //  
  WndClass.hIcon   = LoadIcon(hInstance,"ICON_1"); //   
  WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);  //  
  WndClass.hbrBackground = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)); //  
  WndClass.lpszMenuName = ""; //   
  WndClass.lpszClassName = szClassName; //   

  /*    */
  if (! RegisterClass(&WndClass) )
  {
    MessageBox(NULL,"Cannot register class","Error",MB_OK);
    return 1; //     ,  
  }

  /*   */
  hWnd = CreateWindow(szClassName, //   
  							 "Example N2", //   ( )
                      WS_POPUPWINDOW | WS_CAPTION , //  
                      GetSystemMetrics(SM_CXFULLSCREEN) / 2 - 200,
                      GetSystemMetrics(SM_CYFULLSCREEN) / 2 - 150,
                      400, 300, // , 
                      NULL, //   
                      NULL, //   ( )
                      hInstance, //  
                      NULL); //    

 if (!hWnd)
 {
   MessageBox(NULL,"Cannot create Window","Error",MB_OK);
   return 2; //  ,     
 }

 ShowWindow(hWnd,SW_SHOWNORMAL); //   (  )
 UpdateWindow(hWnd); //    WM_PAINT   

 /*       WM_QUIT */
 while (GetMessage(&Msg, //   
                   NULL, //  ,  NULL,     
                   0,0)) //   ( 0,0,  )
 {
   TranslateMessage(&Msg); //     
   DispatchMessage(&Msg);  //  
 }
 return Msg.wParam; //   ,   WM_QUIT
}



/*   */
LRESULT CALLBACK ExamWndProc
     ( HWND hWnd,     //  ,   
       UINT Message,  //  
       UINT wParam, //  ,     
       LONG lParam ) //  ,     
{
  static HWND wndTea,wndCoffe,wndWater,wndHungry,wndName,wndTitle,wndFiles;
  static int hungry;
  static char name[64];
  int n;

  switch (Message)
  {
   case WM_CREATE  :

      CreateWindow("button","Ok",WS_CHILD | WS_VISIBLE  | WS_TABSTOP | WS_GROUP | BS_DEFPUSHBUTTON,
         10,220,80,40,hWnd,(HMENU) ID_OK,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("button","Cancel",WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON ,
        110,220,80,40,hWnd,(HMENU) ID_CANCEL,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("button","Close",WS_CHILD | WS_VISIBLE |  WS_TABSTOP | BS_PUSHBUTTON ,
        210,220,80,40,hWnd,(HMENU) ID_CLOSE,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("static","",WS_CHILD | WS_VISIBLE |  SS_GRAYFRAME,
        10,10,100,120,hWnd,(HMENU) 0,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("static","Dinner",WS_CHILD | WS_VISIBLE |  SS_LEFT,
        20,20,80,20,hWnd,(HMENU) 0,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("button","Soup",WS_CHILD | WS_VISIBLE | WS_GROUP | BS_AUTOCHECKBOX,
        20,40,80,20,hWnd,(HMENU) ID_SOUP,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("button","Meal",WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
        20,60,80,20,hWnd,(HMENU) ID_MEAL,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("button","Drink",WS_CHILD |  WS_VISIBLE | BS_AUTOCHECKBOX,
        20,80,80,20,hWnd,(HMENU) ID_DRINK,((LPCREATESTRUCT) lParam)->hInstance,NULL);


     CreateWindow("static","",WS_CHILD | WS_VISIBLE |  SS_GRAYFRAME,
      120,10,100,120,hWnd,(HMENU) 0,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      CreateWindow("static","Drink",WS_CHILD | WS_VISIBLE |  SS_LEFT,
        130,20,80,20,hWnd,(HMENU) 0,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      PostMessage(wndTea=CreateWindow("button","Tea",WS_CHILD | WS_VISIBLE | WS_GROUP | BS_AUTORADIOBUTTON,
        130,40,80,20,hWnd,(HMENU) ID_TEA,((LPCREATESTRUCT) lParam)->hInstance,NULL),
        BM_SETCHECK,1,0);

      wndCoffe=CreateWindow("button","Coffe",WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
        130,60,80,20,hWnd,(HMENU) ID_COFFE,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      wndWater=CreateWindow("button","Water",WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
        130,80,80,20,hWnd,(HMENU) ID_WATER,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      EnableWindow(wndTea,false);  EnableWindow(wndCoffe,false);
      ShowWindow(wndWater,SW_HIDE);

      wndHungry=CreateWindow("scrollbar","Hungry",WS_CHILD | WS_VISIBLE | SBS_VERT,
       250,10,GetSystemMetrics(SM_CXHSCROLL),120,hWnd,
        (HMENU) ID_HUNGRY,((LPCREATESTRUCT) lParam)->hInstance,NULL);
      hungry=0;
      SetScrollRange(wndHungry,SB_CTL,hungry,HungryRange,TRUE);

      wndName=CreateWindow("edit","Smith",WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | ES_LEFT,
        20,180,80,20,hWnd,(HMENU) ID_NAME,((LPCREATESTRUCT) lParam)->hInstance,NULL);

      wndFiles=CreateWindow("LISTBOX","",WS_CHILD | WS_VISIBLE | LBS_STANDARD,
        280,20,100,200,hWnd,(HMENU) ID_TITLE,((LPCREATESTRUCT) lParam)->hInstance,NULL);
         SendMessage(wndFiles,LB_DIR,0xFF,(LONG)(LPSTR)"*.*");

      wndTitle=CreateWindow("COMBOBOX","",WS_CHILD | WS_VISIBLE |
         WS_VSCROLL | CBS_AUTOHSCROLL | CBS_DROPDOWNLIST,
        120,180,140,120,hWnd,(HMENU) ID_TITLE,((LPCREATESTRUCT) lParam)->hInstance,NULL);
       SendMessage(wndTitle,CB_ADDSTRING,0,(LONG)(LPSTR)"Mr.");
       SendMessage(wndTitle,CB_ADDSTRING,0,(LONG)(LPSTR)"Ms.");
       SendMessage(wndTitle,CB_ADDSTRING,0,(LONG)(LPSTR)"Dr.");
       SendMessage(wndTitle,CB_SETCURSEL,0,0);


         return 0;

    case WM_COMMAND : // c  
        switch LOWORD(wParam)
        { case ID_OK  : GetWindowText(wndName,name,sizeof(name)-1);
                        MessageBox(hWnd,name," ",MB_OK);
                         break;
          case ID_CANCEL: SendMessage(wndTitle,CB_GETLBTEXT,
                             SendMessage(wndTitle,CB_GETCURSEL,0,0),
                           (long) name);
                          MessageBox(hWnd,name," Cancel!",MB_OK);
                                          break;
          case ID_CLOSE : PostMessage(hWnd,WM_CLOSE,0,0); break;
          case ID_SOUP  : if (SendMessage((HWND)lParam,BM_GETCHECK,0,0))
										 MessageBox(hWnd,"","Soup",MB_OK);
                          else MessageBox(hWnd," ","Soup",MB_OK);
                          break;
          case ID_DRINK : if (SendMessage((HWND)lParam,BM_GETCHECK,0,0))
                           { EnableWindow(wndTea,true);
                             EnableWindow(wndCoffe,true);
                             ShowWindow(wndWater,SW_SHOW);  }
                          else { EnableWindow(wndTea,false);
                                 EnableWindow(wndCoffe,false);
                                 ShowWindow(wndWater,SW_HIDE); }
                          break;
          case ID_NAME:  if (HIWORD(wParam)==EN_CHANGE)
                               MessageBox(hWnd," ","",MB_OK);
                         						 break;

        }
        return 0;

case WM_VSCROLL:
       switch LOWORD(wParam)
       { case SB_PAGEDOWN:
         case SB_BOTTOM:
            hungry=HungryRange;
            break;
		   case SB_PAGEUP:
         case SB_TOP:
            hungry=0;
            break;
		   case SB_LINEUP:
            if (hungry>0) hungry--;
            break;
		   case SB_LINEDOWN:
            if (hungry<HungryRange) hungry++;
            break;
         case SB_THUMBPOSITION:
         case SB_THUMBTRACK:
            hungry=HIWORD(wParam);
            break;
       }
       SetScrollPos(wndHungry,SB_CTL,hungry,TRUE);
       return 0;

   case WM_CLOSE : MessageBeep(MB_ICONQUESTION);
                   if (MessageBox(hWnd," ?"," Exit",
                       MB_ICONQUESTION | MB_YESNO) != IDYES) return 0;

   case WM_DESTROY :
      PostQuitMessage(0); //     WM_QUIT
   	return 0;           //   ,    0

   default :
     //      :
     return DefWindowProc(hWnd,Message,wParam,lParam);
  }
}



